#include <iostream>

class Info {
	int value;

public:
	Info(int v = 0)
	    : value(v) { std::cout << value << ": constructor\n"; }
	Info(const Info& other)
	    : value(other.value) { std::cout << value << ": copy constructor\n"; }
	Info& operator=(const Info& other) {
		value = other.value;
		std::cout << value << ": copy assignment\n";
		return *this;
	}
};

class Container {
	Info info;

public:
	const Info& getInfo() const { return info; }
};

int main() {
	Info a(7);
	Info b = a;
	Info c(a);
	Info d;
	d = a;

	std::cout << "---\n";

	Container x;
	Container y = x;
}
