#include <array>
#include <iostream>

class Engine {
public:
	Engine() { std::cout << "Engine created\n"; }
	~Engine() { std::cout << "Engine destroyed\n"; }
};

class Wheel {
	int n;

public:
	Wheel(int n)
	    : n(n) { std::cout << "Wheel " << n << " created\n"; }
	~Wheel() { std::cout << "Wheel " << n << " destroyed\n"; }
};

class Car {
	Engine engine;
	std::array<Wheel, 4> wheels = { 1, 2, 3, 4 };

public:
	Car() { std::cout << "Car created\n"; }
	~Car() { std::cout << "Car destroyed\n"; }
};

int main() {
	Car car;
}
