#include <iostream>

class Info {
	int value;

public:
	Info(int v = 0)
	    : value(v) { std::cout << value << ": constructor\n"; }
	Info(const Info& other)
	    : value(other.value) { std::cout << value << ": copy constructor\n"; }
	Info& operator=(const Info& other) {
		value = other.value;
		std::cout << value << ": copy assignment\n";
		return *this;
	}
};

Info get() {
	Info x(7);
	// do something
	std::cout << "inside get\n";
	return x;
}

void foo(Info i) {
	// do something
	std::cout << "inside foo\n";
}

int main() {
	Info i = get();
	std::cout << "---\n";
	foo(get());
}
